> For the complete documentation index, see [llms.txt](https://docs-wallet.magiceden.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs-wallet.magiceden.io/evm/signing-a-message.md).

# Signing a Message

Once a web application has connected to the ME Ethereum wallet, it can prompt users to sign messages. Signing is commonplace amongst many dApps, as it gives application owners the ability to verify ownership of the wallet, without requiring any transaction fees.

## Direct Signing

Triggering this directly would look make use of the provider `request` function and look like this:

```typescript
const message =
	"Hello, World! 🌍 Welcome to the Magic Eden wallet on Ethereum";

// can also use Buffer.from for a simpler implementation, but polyfills :/
const msg =
	"0x" +
	Array.from(message)
		.map((c) => c.charCodeAt(0).toString(16).padStart(2, "0"))
		.join("");
const sign = await provider.request({
	method: "personal_sign",
	params: [msg, address, "Example password"],
});
```

## Using Ethers.js

Alternatively, you can make use of the popular web3 javascript library [ethers.js](https://docs.ethers.org/v5/) to abstract away some of the above complexity. Instead of directly invoking `personal_sign` on the provider `request`, you can wrap the ME browser provider in a `Web3Provider` object from ethers. Doing so allows you to invoke the `signMessage` function directly.

```typescript
 const signer = await provider?.getSigner();
 await signer!.signMessage(
   "Hello, World! 🌍 Welcome to the Magic Eden wallet on Ethereum"
 );
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs-wallet.magiceden.io/evm/signing-a-message.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
